#!/bin/bash
      
echo "Depending on your setup, you might need to run the Script as root."

cd $(pwd)
cd -
cwd="$pwd"
(
cd ./Programs/Source/

g++ -Wall -O3 -march=native tuple-spdz.cpp -o tuple-spdz.o
g++ -Wall -O3 -march=native tuple-gen.cpp -o tuple-gen.o
g++ -Wall -O3 -march=native tuple-gen-fake.cpp -o tuple-gen-fake.o
g++ -Wall -O3 -march=native tuple-gen-offline.cpp -o tuple-gen-offline.o
g++ -Wall -O3 -march=native tuple-gen-fake-offline.cpp -o tuple-gen-fake-offline.o


./tuple-spdz.o "$@"
./tuple-gen.o "$@"
./tuple-gen-fake.o "$@"
./tuple-gen-offline.o "$@"
./tuple-gen-fake-offline.o "$@"
)

(cd -
echo "Start compilation"
echo "Compile Polytuples all"
$cwd/compile.py poly
echo ""
echo "Compile polytuples only offline"
./compile.py poly-offline
echo ""
echo "Compile polytuples fake offline all"
./compile.py polyfake
echo ""
echo "Compile polytuples only fake offline"
./compile.py polyfake-offline
echo ""
echo "Compile MP-SPDZ (with reduced rounds)"
./compile.py poly-spdz
echo ""
echo "Start Computation"
echo "Polytuples all"
./Scripts/mascot.sh poly
echo ""
echo "Polytuples only offline"
./Scripts/mascot.sh poly-offline
echo ""
echo "Polytuples fake offline all"
./Scripts/mascot.sh polyfake
echo ""
echo "Polytuples only fake offline"
./Scripts/mascot.sh polyfake-offline
echo ""
echo "MP-SPDZ (with reduced rounds)"
./Scripts/mascot.sh poly-spdz
)