#ifndef INCLUDE_GUARD_REGISTER_SPAN
#define INCLUDE_GUARD_REGISTER_SPAN

#include <span>

template<typename ValueType, typename IndexType = int>
class register_span
{
    std::span<ValueType> data;
    std::span<IndexType const> indices;
    IndexType const offset;

public:
    template<typename ValueRange, typename IndexRange>
    constexpr register_span(ValueRange&& value, IndexRange&& index, IndexType delta = 0)
        : data(std::forward<ValueRange>(value))
        , indices(std::forward<IndexRange>(index))
        , offset(delta)
    {
    }

    constexpr ValueType& operator[](std::size_t i) const
    {
        return data[indices[i] + offset];
    }

    constexpr std::size_t size() const
    {
        return indices.size();
    }
};

#endif